table_scale_time_hours = {
'0': 60.,
'1': 1.,
'2': float(1.0/24.0),
'3': float(1.0/720.0),
'4': float(1.0/(365.0*24.0)),
'5': float(1.0/(10.0*365.0*24.0)),
'6': float(1.0/(30.0*365.0*24.0)),
'7': float(1.0/(100.0*365.0*24.0)),
'8': 1.,
'9': 1.,
'10': 3.,
'11': 6.,
'12': 12.,
'13': 3600.,
'14-255': 1.}

# ---------------------------------------------------------------------------------------- 
# Source: https://github.com/NOAA-EMC/NCEPLIBS-wgrib2/blob/develop/wgrib2/Level.c
#
# The dictionary key is the Section 4.5 coded value.  The value is a list where the
# index 0 is the string to use for level and index 1 is the string for a layer.
# ---------------------------------------------------------------------------------------- 
table_wgrib2_level_string = {
'0': ["reserved","reserved"],
'1': ["surface","reserved"],
'2': ["cloud base","reserved"],
'3': ["cloud top","reserved"],
'4': ["0C isotherm","reserved"],
'5': ["level of adiabatic condensation from sfc","reserved"],
'6': ["max wind","reserved"],
'7': ["tropopause","reserved"],
'8': ["top of atmosphere","reserved"],
'9': ["sea bottom","reserved"],
'10': ["entire atmosphere","reserved"],
'11': ["cumulonimbus base","reserved"],
'12': ["cumulonimbus top","reserved"],
'13': ["lowest level %g%% integrated cloud cover","reserved"],
'14': ["level of free convection","reserved"],
'15': ["convection condensation level","reserved"],
'16': ["level of neutral buoyancy","reserved"],
'17': ["reserved","reserved"],
'18': ["reserved","reserved"],
'19': ["reserved","reserved"],
'20': ["%g K level","reserved"],
'21': ["lowest level > %g kg/m^3","reserved"],
'22': ["highest level > %g kg/m^3","reserved"],
'23': ["lowest level > %g Bq/m^3","reserved"],
'24': ["highest level > %g Bg/m^3","reserved"],
'25': ["reserved","reserved"],
'26': ["reserved","reserved"],
'27': ["reserved","reserved"],
'28': ["reserved","reserved"],
'29': ["reserved","reserved"],
'30': ["reserved","reserved"],
'31': ["reserved","reserved"],
'32': ["reserved","reserved"],
'33': ["reserved","reserved"],
'34': ["reserved","reserved"],
'35': ["reserved","reserved"],
'36': ["reserved","reserved"],
'37': ["reserved","reserved"],
'38': ["reserved","reserved"],
'39': ["reserved","reserved"],
'40': ["reserved","reserved"],
'41': ["reserved","reserved"],
'42': ["reserved","reserved"],
'43': ["reserved","reserved"],
'44': ["reserved","reserved"],
'45': ["reserved","reserved"],
'46': ["reserved","reserved"],
'47': ["reserved","reserved"],
'48': ["reserved","reserved"],
'49': ["reserved","reserved"],
'50': ["reserved","reserved"],
'51': ["reserved","reserved"],
'52': ["reserved","reserved"],
'53': ["reserved","reserved"],
'54': ["reserved","reserved"],
'55': ["reserved","reserved"],
'56': ["reserved","reserved"],
'57': ["reserved","reserved"],
'58': ["reserved","reserved"],
'59': ["reserved","reserved"],
'60': ["reserved","reserved"],
'61': ["reserved","reserved"],
'62': ["reserved","reserved"],
'63': ["reserved","reserved"],
'64': ["reserved","reserved"],
'65': ["reserved","reserved"],
'66': ["reserved","reserved"],
'67': ["reserved","reserved"],
'68': ["reserved","reserved"],
'69': ["reserved","reserved"],
'70': ["reserved","reserved"],
'71': ["reserved","reserved"],
'72': ["reserved","reserved"],
'73': ["reserved","reserved"],
'74': ["reserved","reserved"],
'75': ["reserved","reserved"],
'76': ["reserved","reserved"],
'77': ["reserved","reserved"],
'78': ["reserved","reserved"],
'79': ["reserved","reserved"],
'80': ["reserved","reserved"],
'81': ["reserved","reserved"],
'82': ["reserved","reserved"],
'83': ["reserved","reserved"],
'84': ["reserved","reserved"],
'85': ["reserved","reserved"],
'86': ["reserved","reserved"],
'87': ["reserved","reserved"],
'88': ["reserved","reserved"],
'89': ["reserved","reserved"],
'90': ["reserved","reserved"],
'91': ["reserved","reserved"],
'92': ["reserved","reserved"],
'93': ["reserved","reserved"],
'94': ["reserved","reserved"],
'95': ["reserved","reserved"],
'96': ["reserved","reserved"],
'97': ["reserved","reserved"],
'98': ["reserved","reserved"],
'99': ["reserved","reserved"],
'100': ["%g mb","%g-%g mb"],
'101': ["mean sea level","reserved"],
'102': ["%g m above mean sea level","%g-%g m above mean sea level"],
'103': ["%g m above ground","%g-%g m above ground"],
'104': ["%g sigma level","%g-%g sigma layer"],
'105': ["%g hybrid level","%g-%g hybrid layer"],
'106': ["%g m underground","%g-%g m underground"],
'107': ["%g K isentropic level","%g-%g K isentropic layer"],
'108': ["%g mb above ground","%g-%g mb above ground"],
'109': ["PV=%g (Km^2/kg/s) surface","reserved"],
'110': ["reserved","reserved"],
'111': ["%g Eta level","%g-%g Eta layer"],
'112': ["reserved","reserved"],
'113': ["%g logarithmic hybrid level","reserved"],
'114': ["snow level","reserved"],
'115': ["%g sigma height level","%g-%g sigma heigh layer"],
'116': ["reserved","reserved"],
'117': ["mixed layer depth","reserved"],
'118': ["%g hybrid height level","%g-%g hybrid height layer"],
'119': ["%g hybrid pressure level","%g-%g hybrid pressure layer"],
'120': ["reserved","reserved"],
'121': ["reserved","reserved"],
'122': ["reserved","reserved"],
'123': ["reserved","reserved"],
'124': ["reserved","reserved"],
'125': ["reserved","reserved"],
'126': ["reserved","reserved"],
'127': ["reserved","reserved"],
'128': ["reserved","reserved"],
'129': ["reserved","reserved"],
'130': ["reserved","reserved"],
'131': ["reserved","reserved"],
'132': ["reserved","reserved"],
'133': ["reserved","reserved"],
'134': ["reserved","reserved"],
'135': ["reserved","reserved"],
'136': ["reserved","reserved"],
'137': ["reserved","reserved"],
'138': ["reserved","reserved"],
'139': ["reserved","reserved"],
'140': ["reserved","reserved"],
'141': ["reserved","reserved"],
'142': ["reserved","reserved"],
'143': ["reserved","reserved"],
'144': ["reserved","reserved"],
'145': ["reserved","reserved"],
'146': ["reserved","reserved"],
'147': ["reserved","reserved"],
'148': ["reserved","reserved"],
'149': ["reserved","reserved"],
'150': ["%g generalized vertical height coordinate","reserved"],
'151': ["soil level %g","reserved"],
'152': ["reserved","reserved"],
'153': ["reserved","reserved"],
'154': ["reserved","reserved"],
'155': ["reserved","reserved"],
'156': ["reserved","reserved"],
'157': ["reserved","reserved"],
'158': ["reserved","reserved"],
'159': ["reserved","reserved"],
'160': ["%g m below sea level","%g-%g m below sea level"],
'161': ["%g m below water surface","%g-%g m ocean layer"],
'162': ["lake or river bottom","reserved"],
'163': ["bottom of sediment layer","reserved"],
'164': ["bottom of thermally active sediment layer","reserved"],
'165': ["bottom of sediment layer penetrated by thermal wave","reserved"],
'166': ["maxing layer","reserved"],
'167': ["bottom of root zone","reserved"],
'168': ["reserved","reserved"],
'169': ["reserved","reserved"],
'170': ["reserved","reserved"],
'171': ["reserved","reserved"],
'172': ["reserved","reserved"],
'173': ["reserved","reserved"],
'174': ["top surface of ice on sea, lake or river","reserved"],
'175': ["top surface of ice, und snow on sea, lake or river","reserved"],
'176': ["bottom surface ice on sea, lake or river","reserved"],
'177': ["deep soil","reserved"],
'178': ["reserved","reserved"],
'179': ["top surface of glacier ice and inland ice","reserved"],
'180': ["deep inland or glacier ice","reserved"],
'181': ["grid tile land fraction as a model surface","reserved"],
'182': ["grid tile water fraction as a model surface","reserved"],
'183': ["grid tile ice fraction on sea, lake or river as a model surface","reserved"],
'184': ["grid tile glacier ice and inland ice fraction as a model surface","reserved"],
'185': ["reserved","reserved"],
'186': ["reserved","reserved"],
'187': ["reserved","reserved"],
'188': ["reserved","reserved"],
'189': ["reserved","reserved"],
'190': ["reserved","reserved"],
'191': ["reserved","reserved"],
'192': ["reserved","reserved"],
'193': ["reserved","reserved"],
'194': ["reserved","reserved"],
'195': ["reserved","reserved"],
'196': ["reserved","reserved"],
'197': ["reserved","reserved"],
'198': ["reserved","reserved"],
'199': ["reserved","reserved"],
'200': ["entire atmosphere (considered as a single layer)","reserved"],
'201': ["entire ocean (considered as a single layer)","reserved"],
'202': ["reserved","reserved"],
'203': ["reserved","reserved"],
'204': ["highest tropospheric freezing level","reserved"],
'205': ["reserved","reserved"],
'206': ["grid scale cloud bottom level","reserved"],
'207': ["grid scale cloud top level","reserved"],
'208': ["reserved","reserved"],
'209': ["boundary layer cloud bottom level","reserved"],
'210': ["boundary layer cloud top level","reserved"],
'211': ["boundary layer cloud layer","reserved"],
'212': ["low cloud bottom level","reserved"],
'213': ["low cloud top level","reserved"],
'214': ["low cloud layer","reserved"],
'215': ["cloud ceiling","reserved"],
'216': ["reserved","reserved"],
'217': ["reserved","reserved"],
'218': ["reserved","reserved"],
'219': ["reserved","reserved"],
'220': ["planetary boundary layer","reserved"],
'221': ["layer between two hybrid levels","reserved"],
'222': ["middle cloud bottom level","reserved"],
'223': ["middle cloud top level","reserved"],
'224': ["middle cloud layer","reserved"],
'225': ["reserved","reserved"],
'226': ["reserved","reserved"],
'227': ["reserved","reserved"],
'228': ["reserved","reserved"],
'229': ["reserved","reserved"],
'230': ["reserved","reserved"],
'231': ["reserved","reserved"],
'232': ["high cloud bottom level","reserved"],
'233': ["high cloud top level","reserved"],
'234': ["high cloud layer","reserved"],
'235': ["%gC ocean isotherm","%g-%gC ocean isotherm layer"],
'236': ["layer between two depths below ocean surface","%g-%g m ocean layer"],
'237': ["bottom of ocean mixed layer","reserved"],
'238': ["bottom of ocean isothermal layer","reserved"],
'239': ["layer ocean surface and 26C ocean isothermal level","reserved"],
'240': ["ocean mixed layer","reserved"],
'241': ["%g in sequence","reserved"],
'242': ["convective cloud bottom level","reserved"],
'243': ["convective cloud top level","reserved"],
'244': ["convective cloud layer","reserved"],
'245': ["lowest level of the wet bulb zero","reserved"],
'246': ["maximum equivalent potential temperature level","reserved"],
'247': ["equilibrium level","reserved"],
'248': ["shallow convective cloud bottom level","reserved"],
'249': ["shallow convective cloud top level","reserved"],
'250': ["reserved","reserved"],
'251': ["deep convective cloud bottom level","reserved"],
'252': ["deep convective cloud top level","reserved"],
'253': ["lowest bottom level of supercooled liquid water layer","reserved"],
'254': ["highest top level of supercooled liquid water layer","reserved"],
'255': ["missing","reserved"],
}

